<?
//$Id$
// WebMoney XML-interface example
//
// Webmoney Transfer (c), Oryol Alexander <eagle.alex@gmail.com>

// Module common functions

include_once('config.php');

///////////////////////////////////////////////////////////////////////////////
// wm_GetSign - WebMoney signing string
// Parameters :
//   $inStr  - string for signing
// Return :
//   string - result of signing
function wm_GetSign($inStr) { 
    global $wmWMSigner;
    $descriptorspec = array(
	0 => array("pipe", "r"),
	1 => array("pipe", "w"),
	2 => array("pipe", "r") );
    $process = proc_open($wmWMSigner, $descriptorspec, $pipes );
    if (is_resource($process)) {
	fwrite($pipes[0], "$inStr\004\r\n");
	fclose($pipes[0]);
	$s = fgets($pipes[1], 133);
	fclose($pipes[1]);
	$return_value = proc_close($process);
	if(strlen($s)<132){
	    die("WMSigner error: $s");
	};
	return $s;
    } else {
	    die("Error create WMSigner process");
	die();
    };
}
/*
// For PHP < 4.3.0
function wm_GetSign($inStr)
{
// execute WMSigner
    $fp = popen('/bin/echo -ne "'.$inStr.'\004\r\n" |'.$wmWMSigner, "r");
    $s = fgets($fp, 133);
    pclose($fp);
    if(strlen($s)==132){
        return $s;
    }else{
        return;
    };
}
*/

///////////////////////////////////////////////////////////////////////////////
// wm_xmlHttpsReq - https query at w3s.webmoney.ru (w3s.wmtransfer.com)
// Parameters :
//   $addr  - interface URL
//            ex: "XMLPurses.asp"
//   $xml - XML request as string
// Return :
//   Result CURL excecution https-query (without headers)
function wm_xmlHttpsReq($addr, $xml){ 
    global $wmURL, $wmCAcert, $wmType, $wmKey, $wmCert, $wmPass;
    $ch = curl_init($wmURL.$addr);
    curl_setopt($ch, CURLOPT_HEADER, 0);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER,1);
    curl_setopt($ch, CURLOPT_POST,1);
    curl_setopt($ch, CURLOPT_POSTFIELDS,$xml);
    #      WebMoney CA:
    curl_setopt($ch, CURLOPT_CAINFO, $wmCAcert);

    # !   curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE)!
    #        DNS.
    
    if($wmType=='light'){
	curl_setopt($ch, CURLOPT_SSLKEY, $wmKey);
	curl_setopt($ch, CURLOPT_SSLKEYPASSWD , $wmPass);
	curl_setopt($ch, CURLOPT_SSLCERT, $wmCert);
    };
    
    $result=curl_exec($ch);
    if( curl_errno($ch) != 0 ) {
	die('CURL_error: ' . curl_errno($ch) . ', ' . curl_error($ch));
    };
    curl_close($ch);
    return $result;
}

///////////////////////////////////////////////////////////////////////////////
// wm_ReqID - generate unique request ID 
// Parameters :
//   none
// Return :
//   string
function wm_ReqID(){
    $time=microtime();
    $int=substr($time,11);
    $flo=substr($time,2,5);
    return $int.$flo;
};

///////////////////////////////////////////////////////////////////////////////
// wm_CheckResp - check w3s.response
// Parameters :
//   $vals  - 'vals' var after xml_parse_into_struct() response
//   $index - 'index' var after xml_parse_into_struct() response
// Return :
//   0 - if all OK
//   string - if error then error description
function wm_CheckResp($vals, $index){
        $retval_idx = $index['RETVAL'][0];
        if (!$retval_idx) die("Incorrect response (no retval)");
        $retval = $vals[$retval_idx]['value'];
	if ($retval != 0) {
	    $desc_idx = $index['RETDESC'][0];
	    if (!$desc_idx) die("Incorrect response (no retdesc)");
	    return $vals[$desc_idx]['value'];
	};
	return 0;
};

///////////////////////////////////////////////////////////////////////////////
// wm_X9Req - X9 interface query
// Parameters :
//   none
// Return :
//   array [ pursename => array [ 'amount' => amount, 'desc' => description ] ]
function wm_X9Req(){
    global $wmType, $wmWMID;
    
    $reqID = wm_ReqID();
    
    $doc = domxml_new_doc('1.0');
    $root = $doc->create_element('w3s.request');
    $root = $doc->append_child($root);
    $tmp = $doc->create_element('reqn');
    $tmp->set_content($reqID);
    $root->append_child($tmp);
    $tmp = $doc->create_element('wmid');
    $tmp->set_content($wmWMID);
    $root->append_child($tmp);
    
    if($wmType=='classic'){
	$tmp = $doc->create_element('sign');
	$tmp->set_content(wm_GetSign($wmWMID.$reqID));
	$root->append_child($tmp);
	$addr = 'XMLPurses.asp';
    } else {
	$addr = 'XMLPursesCert.asp';
    };
    
    $getpurses = $doc->create_element('getpurses');
    $root->append_child($getpurses);
    $tmp = $doc->create_element('wmid');
    $tmp->set_content($wmWMID);
    $getpurses->append_child($tmp);

    $request = $doc->dump_mem(TRUE);
    
    $result = wm_xmlHttpsReq($addr, $request);
    
    $xml_parser = xml_parser_create('UTF-8');
    xml_parse_into_struct($xml_parser, $result, $vals, $index);
    xml_parser_free($xml_parser);

    $check = wm_CheckResp($vals,$index);
    if( $check != 0) die($check);
    
    $purses = array();
    $pursename = '';
    $amount = '';
    $desc = '';
    for($n = 0; $n < count($vals); ++$n){
        $e = $vals[$n];
        switch ($e['tag']){
    	    case 'PURSE':
                switch ($e['type']){
                    case 'open':
                            $pursename = ''; $amount = ''; $desc = '';
                            break;
                    case 'close':
                            $purses[$pursename] = array('amount' => $amount, 'desc' => $desc);
                            break;
                }
                break;
            case 'PURSENAME':
                $pursename = $e['value'];
                break;
            case 'AMOUNT':
                $amount = $e['value'];
                break;
            case 'DESC':
                $desc = $e['value'];
                break;
        }
    }
    return $purses;    
    
};

?>
